from interfaz import *
from PyQt6.QtWidgets import *
import csv
import serial
from functools import partial
import datetime
class MainWindow(QtWidgets.QMainWindow, Ui_MainWindow):
    def __init__(self,*args,**kwargs):
        QtWidgets.QMainWindow.__init__(self,*args,**kwargs)
        self.setupUi(self)
        self.stackedWidget.setCurrentIndex(0)
        self.pushButton1.clicked.connect(self.navegar)
        self.pushButton_2.clicked.connect(self.navegar)
        self.pushButton_3.clicked.connect(self.navegar)
        self.pushButton_4.clicked.connect(self.navegar)
        self.pushButton_5.clicked.connect(self.navegar)
        self.pushButton_6.clicked.connect(self.navegar)
        self.pushButton_7.clicked.connect(self.navegar)
        self.pushButton_8.clicked.connect(self.navegar)
        self.pushButton_9.clicked.connect(self.navegar)
        self.pushButton_10.clicked.connect(self.navegar)
        self.pushButton_11.clicked.connect(self.navegar)
        self.pushButton_12.clicked.connect(self.navegar)
        self.pushButton_13.clicked.connect(self.navegar)
        self.pushButton_14.clicked.connect(self.navegar)
        self.pushButton_15.clicked.connect(self.navegar)
        self.pushButton_16.clicked.connect(self.navegar)
        self.pushButton_17.clicked.connect(self.navegar)
        self.pushButton_18.clicked.connect(self.navegar)
        self.btn_inicio1.clicked.connect(self.navegar)
        self.btn_inicio2.clicked.connect(self.navegar)
        self.pushButton1_2.clicked.connect(self.navegar)
        self.lineEdit.textChanged.connect(self.mostrar_busqueda)
        self.componentes = []
        self.historial = self.carga_historial()
        self.componentes = self.carga_datos()
        self.items =[]
        self.serial = serial.Serial('COM22',115200)
        self.pushButton1.clicked.connect(self.wires)
        self.pushButton_2.clicked.connect(self.develop)
        self.pushButton_3.clicked.connect(self.res)
        self.pushButton_4.clicked.connect(self.diod)
        self.pushButton_5.clicked.connect(self.transi)
        self.pushButton_6.clicked.connect(self.integr)
        self.pushButton_7.clicked.connect(self.cap)
        self.pushButton_8.clicked.connect(self.induc)
        self.pushButton_9.clicked.connect(self.digital)
        self.pushButton_10.clicked.connect(self.pcb)
        self.pushButton_11.clicked.connect(self.energy)
        self.pushButton_12.clicked.connect(self.sensors)
        self.pushButton_13.clicked.connect(self.transd)
        self.pushButton_14.clicked.connect(self.com)
        self.pushButton_15.clicked.connect(self.nails)
        self.pushButton_16.clicked.connect(self.mechanic)
        self.pushButton_17.clicked.connect(self.auto)
        self.pushButton_18.clicked.connect(self.electro)

    def wires(self):
        self.serial.write(b"A")
    
    def develop(self):
        self.serial.write(b"B")
    
    def res(self):
        self.serial.write(b"C")

    def diod(self):
        self.serial.write(b"D")

    def transi(self):
        self.serial.write(b"E")

    def integr(self):
        self.serial.write(b"F")
    
    def cap(self):
        self.serial.write(b"G")
    
    def induc(self):
        self.serial.write(b"H")

    def digital(self):
        self.serial.write(b"I")

    def pcb(self):
        self.serial.write(b"J")

    def energy(self):
        self.serial.write(b"K")

    def sensors(self):
        self.serial.write(b"L")

    def transd(self):
        self.serial.write(b"M")

    def com(self):
        self.serial.write(b"N")
    
    def nails(self):
        self.serial.write(b"O")
    
    def mechanic(self):
        self.serial.write(b"P")

    def auto(self):
        self.serial.write(b"Q")

    def electro(self):
        self.serial.write(b"R")
        

    
    def sendColors(self):
        red_value = self.sld_red.value()
        green_value = self.sld_green.value()
        blue_value = self.sld_blue.value()
        self.serial.write(f"{red_value},{green_value},{blue_value}\n".encode())

    def carga_historial(self):
        try:
            with open('historial.csv','r') as archivo:
                lector = csv.reader(archivo)
                datos = []
                for row in lector:
                    datos.append(row)
            return datos
        except:
            return None
    def carga_datos(self):
        try:
            with open('componentes.csv','r') as archivo:
                lector = csv.reader(archivo)
                datos = []
                for row in lector:
                    datos.append(row)
            return datos
        except:
            return None
        
    def actualizar_stock(self,item,cantidad):
        try:
            for i in self.componentes:
                if i[1] == item and (int(i[2]) - cantidad[0]) >= 0:
                    i[2] = int(i[2]) - cantidad[0]
                    break
            with open('componentes.csv','w',newline='') as archivo:
                escritor = csv.writer(archivo)
                for row in self.componentes:
                    escritor.writerow(row)
        except:
            return None

    def navegar(self):
        boton = self.sender()
        if boton.objectName() == 'btn_inicio1' or boton.objectName() == 'btn_inicio2':
            self.stackedWidget.setCurrentIndex(0)
            self.items =[]
            self.borrar_layout(self.gridLayout_2)
        elif boton.objectName() == 'pushButton1_2':
            self.stackedWidget.setCurrentIndex(2)
            self.escribir_historial()
        else:
            boton = boton.objectName()
            boton = boton[-1]
            self.stackedWidget.setCurrentIndex(1)
            for i in self.componentes:
                if i[0] == boton:
                    self.items.append(i)
            self.crear(self.items)

    def crear(self,lista):
        self.lista = QWidget(parent=self.scrollAreaWidgetContents_2)
        self.lista.setGeometry(QtCore.QRect(12,115,1050,665))
        self.lista.setObjectName("lista")
        for i in range(len(lista)):
            self.frame_item = QtWidgets.QFrame(parent=self.scrollAreaWidgetContents_2)
            self.frame_item.setMaximumSize(QtCore.QSize(380, 116))
            self.frame_item.setStyleSheet("border-radius: 25px;\n"
    "background-color: #4d82bc;")
            self.frame_item.setFrameShape(QtWidgets.QFrame.Shape.StyledPanel)
            self.frame_item.setFrameShadow(QtWidgets.QFrame.Shadow.Raised)
            self.frame_item.setObjectName("frame_item")
            self.btn_item = QtWidgets.QPushButton(parent=self.frame_item)
            self.btn_item.setGeometry(QtCore.QRect(0, 0, 380, 116))
            self.btn_item.setMinimumSize(QtCore.QSize(380, 116))
            self.btn_item.setMaximumSize(QtCore.QSize(380, 116))
            self.btn_item.setStyleSheet("QPushButton:hover{\n"
    "background-color: #84b6f4;\n"
    "}\n"
    "QPushButton{\n"
    "background-color: rgba(255, 255, 255,0);\n"
    "border-radius: 25px;\n"
    "}")
            self.btn_item.setText("")
            self.btn_item.setObjectName(lista[i][1])
            self.label_item = QtWidgets.QLabel(parent=self.frame_item)
            self.label_item.setGeometry(QtCore.QRect(10, 20, 151, 51))
            self.label_item.setStyleSheet("background-color: rgba(255, 255, 255,0);")
            self.label_item.setWordWrap(True)
            self.label_item.setObjectName("label_item")
            self.label_item.setText(lista[i][1])
            self.label_stock = QtWidgets.QLabel(parent=self.frame_item)
            self.label_stock.setGeometry(QtCore.QRect(260, 20, 111, 51))
            self.label_stock.setStyleSheet("background-color: rgba(255, 255, 255,0);")
            self.label_stock.setObjectName("label_stock")
            self.label_stock.setText(f'Stock: {str(lista[i][2])}')
            self.btn_item.raise_()
            self.label_stock.raise_()
            self.label_item.raise_()
            fila = i // 2 
            columna = i % 2
            self.gridLayout_2.addWidget(self.frame_item,fila,columna)
            self.btn_item.clicked.connect(partial(self.pedir_item,lista[i][1]))
    def mostrar_busqueda(self):
        busqueda = self.lineEdit.text().lower()
        if busqueda:
            self.borrar_layout(self.gridLayout_2)
            componentes_buscados = []
            for i in self.componentes:
                nombre_componente = i[1]
                if busqueda in nombre_componente.lower():
                    componentes_buscados.append(i)
            self.crear(componentes_buscados)
        else:
            self.crear(self.componentes)
    
    def borrar_layout (self,layout):
        while layout.count():
                child = layout.takeAt(0)
                if child.widget():
                    child.widget().deleteLater()
    
    def pedir_item(self,item):
        cantidad = QInputDialog.getInt(self, "Ingresa la cantidad que deseas", f"Cantidad de: {item}")
        self.actualizar_stock(item,cantidad)
        fecha = datetime.date.today()
        pedido = [item,cantidad[0],fecha]
        self.agregar_pedido(pedido)
        self.historial = self.carga_historial()
        self.escribir_historial()
        self.crear(self.items)
    
    def agregar_pedido(self,pedido):
        try:
            with open('historial.csv','a',newline='') as archivo:
                escritor = csv.writer(archivo)
                escritor.writerow(pedido)
        except:
            print("Algo salio mal")
    def escribir_historial(self):
        for p in self.historial:
            self.listWidget.addItem(f'Componente:{p[0]}     Cantidad:{p[1]}    Fecha: {p[2]}')
    
    #A partir de aquí la lógica

    



if __name__=='__main__':
    app = QtWidgets.QApplication([])
    window = MainWindow()
    window.show()
    app.exec()
   